unit procedureListLoader;

interface

uses
  procedureList;

procedure LoadProcedureList(const fileName: string; procedureList: TProcedureList);

implementation

procedure Sort(procedures: TArray<string>);
var
  i: integer;
  swapped: boolean;
  temp: string;
begin
  repeat
    swapped := false;
    for i := 1 to High(procedures) do begin
      if procedures[i-1] > procedures[i] then begin
        temp := procedures[i-1];
        procedures[i-1] := procedures[i];
        procedures[i] := temp;
        swapped := true;
      end;
    end;
  until not swapped;
end;

procedure LoadProcedureList(const fileName: string; procedureList: TProcedureList);
var
  ch: char;
  f: textfile;
  procName: string;
  procedures: TArray<string>;
begin
  SetLength(procedures, 0);
  Assign(f, fileName);
  Reset(f);
  while not Eof(f) do begin
    procName := '';
    while not Eoln(f) do begin
      Read(f, ch);
      procName := procName + ch;
    end;
    Readln(f);
    if procName <> '' then begin
      SetLength(procedures, Length(procedures) + 1);
      procedures[High(procedures)] := procName;
    end;
  end;
  Close(f);
  Sort(procedures);
  for procName in procedures do
    procedureList.Add(procName);
end;

end.
